{
CMOS.PAS - jednotka pro praci s pameti CMOS
(C) 1997 PEERSOFT

     Tato jednotka dovoluje uzivateli cteni a zapis
     do pameti CMOS.
     Uzivatel ma z teto jednotky pristup ke trem podprogramum a
     k promenne CMOSOK, ktera mu napovi, byla-li operace
     provedena v poradku.}

UNIT CMOS;

INTERFACE

VAR CMOSOK:BOOLEAN; {tato promenna by se mela po kazde operaci s
           podprogramy testovat. Ma-li hodnotu TRUE,
           probehla operace v poradku. V opacnem pripade je
           mozna pricina chyby chybne zadani adresy zapisu
           nebo poctu zapisovanych znaku.}

           FUNCTION CMOSRead (Addr : BYTE) : BYTE;
PROCEDURE CMOSWrite (Addr, Val : BYTE);
PROCEDURE CMOSFill (Addr, Val, Count : BYTE);

IMPLEMENTATION

FUNCTION CMOSRead; assembler;
{Dovoli nacist jeden byte z adresy dane parametrem Addr.
 Adresa muze byt pouze v rozsahu 0 - 63.
 Vysledek je vracen take jako byte.
}

asm
mov al,addr
cmp al,40H
mov ah,0
jae @@1
out 70H,al
xor cx,cx
in al,71H
mov ah,1
@@1:
mov byte ptr cmosok,ah
end;

PROCEDURE CMOSWrite; assembler;
{Tato procedura umoznuje zapis jedne hodnoty do pameti CMOS.
 Parametr Addr oznacuje adresu zapisu.
  Parametr Val predstavuje hodnotu, ktera se ma zapsat.
 }

 asm
 mov al,addr
cmp al,40H
mov ah,0
jae @@1
 out 70H,al
 mov al,Val
xor cx,cx
out 71H,al
mov ah,1
@@1:
mov byte ptr cmosok,ah
 end;

 PROCEDURE CMOSFill;
 {
 Procedura vyplni prostor o dane delce v pameti CMOS znakem.
  Parametr Addr je pocatecni adresa vyplne.
  Parametr Val je hodnota, ktera se ma pouzit pro vypln.
  Count je pocet vyplnovanych bajtu pocinaje pocatecni adresou.
}
var i:byte;
BEGIN
if (addr>$3F) or (addr+count>$40) then begin
cmosok:=false;
exit;
end;
for i:=1 to count do cmoswrite(pred(addr)+i,val);
cmosok:=true;
end;
end.
